//
//  BDLinkArrowCell.m


#import "BDLinkArrowCell.h"
#import "AppDelegate.h"

@implementation BDLinkArrowCell

- (id)initWithCoder:(NSCoder *)coder
{
	self = [super initWithCoder:coder];
	if (self)
	{
		// Set up link arrow.
		linkArrow = [[NSButtonCell alloc] init];
		[linkArrow setButtonType:NSSwitchButton];
		[linkArrow setBezelStyle:NSSmallSquareBezelStyle];
		[linkArrow setImagePosition:NSImageRight];
		[linkArrow setTitle:@""];
		[linkArrow setBordered:NO];
		[linkArrow setImage:[NSImage imageNamed:NSImageNameFollowLinkFreestandingTemplate]];
		[linkArrow setAlternateImage:[NSImage imageNamed:NSImageNameFollowLinkFreestandingTemplate]];
	}
	return self;
}

- (void)encodeWithCoder:(NSCoder *)coder
{
	[super encodeWithCoder:coder];
}

- (void)setLinkVisible:(BOOL)isVisible
{
	isLinkVisible = isVisible;
}

- (void)drawInteriorWithFrame:(NSRect)aRect inView:(NSView *)controlView
{
	NSRect textRect = NSMakeRect(aRect.origin.x, aRect.origin.y, aRect.size.width - 18, aRect.size.height);
	linkRect = NSMakeRect(aRect.origin.x + aRect.size.width - 12, aRect.origin.y, 12, aRect.size.height);

	// Draw text.
	[super drawInteriorWithFrame:textRect inView:controlView];

	// Draw link arrow.
	if (isLinkVisible)
		[linkArrow drawInteriorWithFrame:linkRect inView:controlView];
}

// 10.5+ method
- (NSUInteger)hitTestForEvent:(NSEvent *)event inRect:(NSRect)cellFrame ofView:(NSView *)controlView
{
	NSPoint p = [[[NSApp  mainWindow] contentView] convertPoint:[event locationInWindow] toView:controlView];
	if (p.x > linkRect.origin.x && p.x < (linkRect.origin.x + linkRect.size.width))
	{
		// Hit the link.
		[[NSApp delegate] openURLInBrowser:nil];
		return NSCellHitContentArea | NSCellHitEditableTextArea;
	}
	else
	{
		return NSCellHitNone;
	}
}

@end
