//
//  BDSourceListController.m


#import "BDSourceListController.h"
#import "Feed.h"
#import "BDBadgeCell.h"
#import "AppDelegate.h"

@implementation BDSourceListController

- (void)awakeFromNib
{
}

- (NSInteger)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return [[feeds arrangedObjects] count];
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(NSInteger)rowIndex
{
	return [[[feeds arrangedObjects] objectAtIndex:rowIndex] valueForKeyPath:@"properties.title"];
}

- (void)tableView:(NSTableView *)aTableView willDisplayCell:(id)aCell forTableColumn:(NSTableColumn *)aTableColumn row:(NSInteger)rowIndex
{
	Feed *currentFeed = [[feeds arrangedObjects] objectAtIndex:rowIndex];
	[aCell setBadgeCount:[[currentFeed feedItems] count]];
	[aCell setImage:[currentFeed valueForKeyPath:@"properties.icon"]];
}

- (void)tableViewSelectionDidChange:(NSNotification *)notification
{
	[feeds setSelectionIndex:[sourceList selectedRow]];
	[[NSApp delegate] updateWebView];
}

@end
